package net.northking.cctp.element.string.enums;

import com.alibaba.fastjson.JSON;
import net.northking.cctp.element.core.type.EnumClass;

import java.util.*;

/**
 * TypeConversionEnum
 *
 * @author fengxiang.zhang
 * @since 1.0
 */
public enum TypeConversionReplaceEnum implements EnumClass {
    replaceByValue("根据字符串替换", "0"),
    replaceByTimes("根据字符串以及次数替换", "1"),
    ;

    private String key;
    private String value;

    TypeConversionReplaceEnum(String key, String value) {
        this.key = key;
        this.value = value;
    }

    public static TypeConversionReplaceEnum from(String value) {
        for (TypeConversionReplaceEnum item : TypeConversionReplaceEnum.values()) {
            if (item.value.equals(value)) {
                return item;
            }
        }
        throw new IllegalArgumentException("未知的转换类型:" + value);
    }

    @Override
    public String getEnumData() {
        List<Map<String, Object>> result = new ArrayList<>();
        for (TypeConversionReplaceEnum item : EnumSet.allOf(TypeConversionReplaceEnum.class)) {
            Map<String, Object> one = new HashMap(1);
            one.put("label", item.key);
            one.put("value", item.value);
            result.add(one);
        }
        return JSON.toJSONString(result);
    }
}
